// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	"time"

	v1beta1 "github.com/tg123/sshpiper/plugin/kubernetes/apis/sshpiper/v1beta1"
	scheme "github.com/tg123/sshpiper/plugin/kubernetes/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// PipesGetter has a method to return a PipeInterface.
// A group's client should implement this interface.
type PipesGetter interface {
	Pipes(namespace string) PipeInterface
}

// PipeInterface has methods to work with Pipe resources.
type PipeInterface interface {
	Create(ctx context.Context, pipe *v1beta1.Pipe, opts v1.CreateOptions) (*v1beta1.Pipe, error)
	Update(ctx context.Context, pipe *v1beta1.Pipe, opts v1.UpdateOptions) (*v1beta1.Pipe, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.Pipe, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.PipeList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.Pipe, err error)
	PipeExpansion
}

// pipes implements PipeInterface
type pipes struct {
	client rest.Interface
	ns     string
}

// newPipes returns a Pipes
func newPipes(c *SshpiperV1beta1Client, namespace string) *pipes {
	return &pipes{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the pipe, and returns the corresponding pipe object, and an error if there is any.
func (c *pipes) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.Pipe, err error) {
	result = &v1beta1.Pipe{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("pipes").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of Pipes that match those selectors.
func (c *pipes) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.PipeList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta1.PipeList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("pipes").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested pipes.
func (c *pipes) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("pipes").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a pipe and creates it.  Returns the server's representation of the pipe, and an error, if there is any.
func (c *pipes) Create(ctx context.Context, pipe *v1beta1.Pipe, opts v1.CreateOptions) (result *v1beta1.Pipe, err error) {
	result = &v1beta1.Pipe{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("pipes").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(pipe).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a pipe and updates it. Returns the server's representation of the pipe, and an error, if there is any.
func (c *pipes) Update(ctx context.Context, pipe *v1beta1.Pipe, opts v1.UpdateOptions) (result *v1beta1.Pipe, err error) {
	result = &v1beta1.Pipe{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("pipes").
		Name(pipe.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(pipe).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the pipe and deletes it. Returns an error if one occurs.
func (c *pipes) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("pipes").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *pipes) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("pipes").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched pipe.
func (c *pipes) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.Pipe, err error) {
	result = &v1beta1.Pipe{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("pipes").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
